#line 5 "/home/dodo/tmp/obpager-1.8/mu/src/main.u"

#include <sys/ipc.h>
#include <sys/shm.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/extensions/XShm.h>


#line 600 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

typedef struct 
{
  uint32_t *data;
  unsigned int width,height, bpl;
  int shared;
  XShmSegmentInfo shminfo;
  XImage *x11image;
} ximage_t;

#line 811 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

typedef struct xwindow
{
  Window   x11window;
  uint32_t width, height;
  uint32_t *data;
  ximage_t *image;
  void     *user_data;
  void    (*event_handler)(struct xwindow*, XEvent*);
} xwindow_t;

#line 5 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"

typedef struct 
{
  Window id;
  uint32_t flags, tried;
  int x,y;
  unsigned long width, height;
  uint32_t icon_width, icon_height;
  uint32_t *icon_data;
  int state;  // 0- normal 1- minimized etc.
  int type;   // 0- normal 1- other
  unsigned long desk;
} client_window_t;

#line 25 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"
#define CWF_POS    1      // x,y, width, height
#define CWF_ICON   2
#define CWF_STATE  4
#define CWF_TYPE   8
#define CWF_DESK   16

#line 721 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

typedef struct image_chore_t
{
  struct image_chore_t *next;
  int kind;
  void *data;
} image_chore_t;

enum { image_chore_shmdt };

#line 13 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

Display *x_display;
Window x_root_window;
int x_screen_number;
uint32_t x_root_width, x_root_height;
uint32_t x_n_desktops;
uint32_t x_current_desktop;

#line 69 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

#line 82 "mupager-main.c"
Atom a_,
  a_utf8_string,
  a_net_current_desktop,
  a_net_number_of_desktops,
  a_net_supported,
  a_net_client_list_stacking,
  a_net_wm_desktop,
  a_net_active_window,
  a_net_desktop_geometry,
  a_net_supporting_wm_check,
  a_net_wm_name,
  a_net_wm_icon,
  a_wm_name,
  a_net_wm_window_type,
  a_net_wm_window_type_dock,
  a_net_wm_window_type_normal,
  a_net_wm_state,
  a_net_wm_state_sticky,
  a_net_wm_state_skip_taskbar,
  a_net_wm_state_skip_pager,
  a_net_wm_state_hidden,
  a_net_frame_extents;
#line 583 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

uint32_t x_red_mask, x_red_shift, x_green_mask, x_green_shift,
         x_blue_mask, x_blue_shift;
int x_depth;

Visual *x_visual;

#line 36 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"

client_window_t **client_map; int n_client_map;

#line 404 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"

xwindow_t* pager_window;

#line 21 "/home/dodo/tmp/obpager-1.8/mu/src/main.u"

int opt_right, opt_bottom, opt_refsize= 40;

#line 732 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

static image_chore_t *image_chores;

#line 868 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

static xwindow_t **window_map;
static int       n_window_map, s_window_map;

#line 268 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"

uint32_t pc_border= 0xededed;
uint32_t pc_a_root= 0x376594;
uint32_t pc_a_window= 0x85bcf6;
uint32_t pc_a_window_border= 0xffffff;
uint32_t pc_i_root= 0xa6a6a6;
uint32_t pc_i_window= 0xededed;
uint32_t pc_i_window_border= 0x313739;
uint32_t pc_converted;

#line 144 "mupager-main.c"

static void intern_atoms();
static int get_x_visual();
static uint32_t trailing_zero_bits(uint32_t Y);
static int can_use_shared_images();
static ximage_t *ximage_create_simple(uint32_t width,uint32_t height);
static void register_window(Window x11window, xwindow_t *window);
static void unregister_window(xwindow_t *window);
static xwindow_t *find_window(Window x11window);
int init_display(char *name);
int get_window_property
    (Window window, Atom property, Atom type,
     Atom *Rtype,int *Rformat,  int *Rsize, void **Rdata,
     unsigned long max_size);
int get_window_property_cardinals
    (Window window, Atom property, size_t *Rn, unsigned long **R, int maxn);
int get_window_property_cardinal
    (Window window, Atom property, unsigned long *R);
int get_number_of_desktops(uint32_t *D);
int get_current_desktop(uint32_t *D);
int set_current_desktop(int nr);
int get_window_property_windows
    (Window window, Atom property, size_t *Rn, Window **R, int maxn);
void *convert_integers(unsigned char *src, int src_el, int src_n, int dst_el);
int get_window_property_atoms
    (Window window, Atom property, size_t *Rn, Atom **R, int maxn);
int get_window_property_window
    (Window window, Atom property, Window *R);
int get_window_property_utf8_string
    (Window window, Atom property, size_t *Rn, char **R);
char *get_active_window_manager_name();
int set_window_property_atoms
        (Window window, Atom property, int n_values, Atom *values);
ximage_t *create_image(uint32_t width, uint32_t height);
void destroy_image(ximage_t *image);
void handle_image_chores();
void put_image(Window window, int dest_x, int dest_y,
               ximage_t *image, int src_x, int src_y,
               int width, int height);
xwindow_t *create_window(int x,int y,uint32_t width, uint32_t height);
void destroy_window(xwindow_t *window);
void invalidate_window(xwindow_t *window);
int dispatch_window_event(XEvent *event);
int handle_window_event(xwindow_t *window, XEvent *event);
void destroy_client_window(client_window_t *cw);
int get_client_list();
uint32_t* copy_ulong_to_uint32(unsigned long *data,uint32_t elems);
int get_client_icon(client_window_t *cw, uint32_t twidth, uint32_t theight);
int get_client_pos(client_window_t *cw);
int get_client_state(client_window_t *cw);
int get_client_type(client_window_t *cw);
int get_client_desktop_number(client_window_t *cw);
void render_pager_background
   (xwindow_t *window, int ndesks, 
    int *Rpadl, int *Rpadt, int *Rpagew, int *Rpageh);
void render_mini_window(xwindow_t *window, int ndesks, 
                        int padl, int padt, int pagew, int pageh,
                        client_window_t *cw);
void convert_pager_color(uint32_t *tgt);
void render_pager_window();
void argb_to_a_server(uint32_t V, uint32_t *A, uint32_t *P);
void draw_client_icon
     (xwindow_t *window,client_window_t *cw,int x,int y,int w,int h,
      int active);
void handle_root_event(XEvent *event);
int handle_client_event(XEvent *event);
void window_fill_rectangle
   (xwindow_t *window,uint32_t color, int x,int y, int w, int h);
void window_draw_rectangle
   (xwindow_t *window,uint32_t color, int x,int y, int w, int h);
void window_horz_line
   (xwindow_t *window,uint32_t color, int x1, int x2, int y);
void window_vert_line
   (xwindow_t *window,uint32_t color, int x, int y1, int y2);
void pager_window_shape(int ref, int bot_off, int right_off,
                        int *window_w, int *window_h,
                        int *window_x, int *window_y);
void usage();
#line 90 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

static void intern_atoms()
{
   typedef struct { char* name; Atom *atom; } atomdesc_t;
   static atomdesc_t atoms[]=
   {
#line 229 "mupager-main.c"
  { "", &a_ },
  { "UTF8_STRING", &a_utf8_string },
  { "_NET_CURRENT_DESKTOP", &a_net_current_desktop },
  { "_NET_NUMBER_OF_DESKTOPS", &a_net_number_of_desktops },
  { "_NET_SUPPORTED", &a_net_supported },
  { "_NET_CLIENT_LIST_STACKING", &a_net_client_list_stacking },
  { "_NET_WM_DESKTOP", &a_net_wm_desktop },
  { "_NET_ACTIVE_WINDOW", &a_net_active_window },
  { "_NET_DESKTOP_GEOMETRY", &a_net_desktop_geometry },
  { "_NET_SUPPORTING_WM_CHECK", &a_net_supporting_wm_check },
  { "_NET_WM_NAME", &a_net_wm_name },
  { "_NET_WM_ICON", &a_net_wm_icon },
  { "WM_NAME", &a_wm_name },
  { "_NET_WM_WINDOW_TYPE", &a_net_wm_window_type },
  { "_NET_WM_WINDOW_TYPE_DOCK", &a_net_wm_window_type_dock },
  { "_NET_WM_WINDOW_TYPE_NORMAL", &a_net_wm_window_type_normal },
  { "_NET_WM_STATE", &a_net_wm_state },
  { "_NET_WM_STATE_STICKY", &a_net_wm_state_sticky },
  { "_NET_WM_STATE_SKIP_TASKBAR", &a_net_wm_state_skip_taskbar },
  { "_NET_WM_STATE_SKIP_PAGER", &a_net_wm_state_skip_pager },
  { "_NET_WM_STATE_HIDDEN", &a_net_wm_state_hidden },
  { "_NET_FRAME_EXTENTS", &a_net_frame_extents },
#line 114 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"
      { NULL, NULL }
   };
   int i;
   for(i=0;atoms[i].name;i++)
     if ((atoms[i].atom[0]= XInternAtom(x_display, atoms[i].name, True))
            ==None)
     {
           // FIXME: proper logging
       fprintf(stderr,"Can't intern atom %s\n", atoms[i].name);
     }
}

#line 524 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

static int get_x_visual()
{
  int depth, ndepths, i;
  int *depths;
  XVisualInfo xvinfo;

  depths= XListDepths(x_display, x_screen_number, &ndepths);
  if (!depths) 
  {
    fprintf(stderr,"can't get depth list for display\n");
    return 1;
  }

  depth=0;
  for(i=0;i<ndepths;i++)
    if (depths[i]==32 || depths[i]==24)
    {
      depth= depths[i];
      break;
    }
  XFree(depths);

  if (!depth)
  {
    fprintf(stderr, "display doesn't support 24 or 32 bit depth.\n");
    return 1;
  }

  x_depth= depth;
  x_visual= NULL;
  if (XMatchVisualInfo(x_display, x_screen_number, depth, TrueColor,&xvinfo))
     x_visual= xvinfo.visual;
  else if (XMatchVisualInfo(x_display, x_screen_number,
                                       depth, DirectColor,&xvinfo))
     x_visual= xvinfo.visual;
  else
  {
    fprintf(stderr,"can't find a 24 or 32 bit TrueColor/DirectColor visual\n");
    return 1;
  }
  x_red_mask= x_visual->red_mask;
  x_red_shift= trailing_zero_bits(x_red_mask);
  x_green_mask= x_visual->green_mask;
  x_green_shift= trailing_zero_bits(x_green_mask);
  x_blue_mask= x_visual->blue_mask;
  x_blue_shift= trailing_zero_bits(x_blue_mask);
  return 0;
}


static uint32_t trailing_zero_bits(uint32_t Y)
{
  uint32_t shif;
  for(shif=0;Y%2==0;shif++) Y= Y>>1;
  return shif;
}

#line 678 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

static int can_use_shared_images()
{
  static int tried;
  static int can;
  if (!tried)
  {
    int ignore, major, minor;
    Bool pixmaps;
    tried= 1;
    can= XQueryExtension(x_display, "MIT-SHM", &ignore, &ignore, &ignore)
         && XShmQueryVersion(x_display, &major, &minor, &pixmaps);
  }
  return can;
}

static ximage_t *ximage_create_simple(uint32_t width,uint32_t height)
{
  ximage_t *image;

  image= calloc(1,sizeof(*image));
  image->width= width;
  image->height= height;
  image->data= malloc(sizeof(uint32_t)*width*height);

  image->x11image= XCreateImage(x_display, x_visual, x_depth,
                                ZPixmap, 0, (char*) image->data,
                                width, height, 32, width*sizeof(uint32_t));
      // FIXME: error checking??
  image->bpl= image->x11image->bytes_per_line;
  image->shared= 0;
  return image;
}

#line 873 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

static void register_window(Window x11window, xwindow_t *window)
{
   if (n_window_map==s_window_map)
   {
     if (s_window_map==0)  
     {
        s_window_map= 50;
        window_map= malloc(sizeof(xwindow_t*)*s_window_map);
     } 
     else
     {
        s_window_map += s_window_map/2;
        window_map= realloc(window_map,sizeof(xwindow_t*)*s_window_map);
     }
   }
   window_map[n_window_map++]= window;
}

static void unregister_window(xwindow_t *window)
{
  int i;
  for(i=0;i<n_window_map;i++)
    if (window_map[i]==window)
    {
      window_map[i]= window_map[n_window_map-1];
      n_window_map--;
      break;
    }
}

static xwindow_t *find_window(Window x11window)
{
  int i;
  for(i=0;i<n_window_map;i++)
    if (window_map[i]->x11window==x11window)
       return window_map[i];
  return NULL;
}

#line 22 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

int init_display(char *name)
{
  x_display= XOpenDisplay(name);

  if (!x_display) 
  {
    //FIXME: log this
    fprintf(stderr,"can't open display\n");
    return 1;
  }
  
  x_screen_number= DefaultScreen(x_display);
  x_root_window= DefaultRootWindow(x_display);

  intern_atoms();

  if (get_x_visual())
  {
    XCloseDisplay(x_display);
    x_display= NULL;
    return 1;
  }

  x_root_width= DisplayWidth(x_display, x_screen_number);
  x_root_height= DisplayHeight(x_display, x_screen_number);

  if (get_number_of_desktops(&x_n_desktops)) x_n_desktops= 1;
  if (get_current_desktop(&x_current_desktop)) x_current_desktop= 0;

  return 0;
}

#line 162 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

int get_window_property
    (Window window, Atom property, Atom type,
     Atom *Rtype,int *Rformat,  int *Rsize, void **Rdata,
     unsigned long max_size)
{
  unsigned long bytes_remaining, offset, size;
  unsigned char *data;
  int R;

  Atom r_type; int r_format; unsigned long r_nitems, r_size;
  Atom f_type; int f_format; 
  unsigned char *r_data; 
  unsigned long cp;

  *Rdata= NULL;
  if (x_display==NULL || property==None) goto fail_bad_usage; 
  if (window==None) window= x_root_window;

#if 0
  offset= 0;
  data= NULL;

  do
  {
    R= XGetWindowProperty(x_display, window, property, 
                 offset/4, // offset
                 256, // length in 32-bit items.. stuuupid.
                False, // delete
                type, 
             &r_type, &r_format, &r_nitems, 
             &bytes_remaining, // this one is in BYTES.
             &r_data);


    if (R!=Success) goto fail_x;

    if (r_format==32) r_format= sizeof(unsigned long)<<3;

    r_size= r_nitems * (r_format>>3);
    // Maybe I should check for r_type==type. the caller can do that..

    if (r_nitems==0) goto fail_x;

    if (property==a_net_wm_icon)
      printf("read %d bytes, %d bytes left\n", (int) r_size, (int) bytes_remaining);

    if (data)
    {
      if (r_format != f_format || r_type != f_type)  goto fail_mismatch;
    } 
    else
    {
      f_format= r_format; f_type= r_type;
      size= r_size + bytes_remaining;
      if (max_size!=0 && size>max_size)  size= max_size;
      data= malloc( size + 1 );
    }
    
    cp= (size - offset);
    if (cp>r_size) cp= r_size;
    memcpy(data+offset, r_data, cp);
    XFree(r_data);
    offset+= cp;

  } while(offset<size && bytes_remaining!=0);

  if (offset<size)
  {
    fprintf(stderr,"window property read was ended abruptly.. strange.\n");
  }

  data[offset]= 0;
  *Rtype= f_type; *Rformat= f_format;
  *Rsize= offset;
  *Rdata= (void*) data;
#else
   if (!max_size) max_size= -1L; else max_size/= 4;
   R= XGetWindowProperty(x_display, window, property, 
                 0, // offset
                 max_size, // length in 32-bit items.. stuuupid.
                False, // delete
                type, 
             Rtype, Rformat, &r_nitems, 
             &bytes_remaining, // this one is in BYTES.
             (unsigned char**) Rdata);

  if (*Rformat==32) *Rformat= sizeof(unsigned long)*8;
  *Rsize= r_nitems * Rformat[0]/8;
  
#endif
  return 0;
  
fail_bad_usage:
  fprintf(stderr,"bad usage in get_window_property\n");
  return 1;

fail_mismatch:
  fprintf(stderr,"returned property types differ in two sequential queries\n");
  if (data) free(data);
  XFree(r_data);
  return 1;
fail_x:
  fprintf(stderr,"X call failed in get_window_property W=%d P=%d\n",(int) window, (int) property);
  if (data) free(data);
  return 1;
}

#line 275 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

int get_window_property_cardinals
    (Window window, Atom property, size_t *Rn, unsigned long **R, int maxn)
{
  int format; Atom type;
  int size; 

  *R= NULL;
  if (get_window_property(window, property, XA_CARDINAL,
                          &type, &format, &size, (void**) R,
                          maxn*sizeof(unsigned long)))
     return 1;
  if (type!=XA_CARDINAL)
  {
    if (*R) free(*R);
    // FIXME: get the name of the atom to print this better.
    // FIXME log this.
    //fprintf(stderr,"type mismatch in get_window_property \n"
                   //"expected a 32-bit uint32_t, but got a %-bit %d\n",
                              //format, type);
    return 1;
  }
  *Rn= size / sizeof(unsigned long);
  return 0;
}


int get_window_property_cardinal
    (Window window, Atom property, unsigned long *R)
{
  unsigned long *data;
  size_t n;
  if (get_window_property_cardinals(window,property, &n, &data, 1))
     return 1;
  if (n==0) { if (data) free(data); return 1; }
  *R= data[0];
  free(data);
  return 0;
}

int get_number_of_desktops(uint32_t *D)
{
  unsigned long V;
  if (get_window_property_cardinal(None, a_net_number_of_desktops, &V)) 
     return 1;
  else *D= V;
  return 0;
}

int get_current_desktop(uint32_t *D)
{
  unsigned long V;
  if (get_window_property_cardinal(x_root_window, a_net_current_desktop, &V)) 
     return 1;
  else *D= V;
  return 0;
}

int set_current_desktop(int nr)
{
  XEvent event;

  event.xclient.type = ClientMessage;
  event.xclient.window = x_root_window;
  event.xclient.message_type= a_net_current_desktop;
  event.xclient.format = 32;
  event.xclient.data.l[0] = nr;
  event.xclient.data.l[1] = 0;
  event.xclient.data.l[2] = 0;
  event.xclient.data.l[3] = 0;
  event.xclient.data.l[4] = 0;

  if (XSendEvent(x_display, x_root_window, False,
                 SubstructureNotifyMask | SubstructureRedirectMask, &event))
    return 0;
  return 1;
}

#line 357 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

int get_window_property_windows
    (Window window, Atom property, size_t *Rn, Window **R, int maxn)
{
  int format; Atom type;
  int size; void *data;

  *R= NULL;
  if (get_window_property(window, property, XA_WINDOW,
                          &type, &format, &size, (void**) R,
                          maxn*sizeof(Window)))
     return 1;
  if (type!=XA_WINDOW)
  {
    if (*R) free(*R);
    // FIXME: get the name of the atom to print this better.
    // FIXME log this.
    //fprintf(stderr,"type mismatch in get_window_property \n"
                   //"expected a window, but got a %d-bit %d\n",
                              //format, type);
    return 1;
  }

  *Rn= size/sizeof(Window); 
  return 0;
}

void *convert_integers(unsigned char *src, int src_el, int src_n, int dst_el)
{
   unsigned char *dst, *out,*in;
   int i;
   if (dst_el==src_el) return src;

   in= src;
   out= dst= malloc(dst_el*src_n);
   for(i=0;i<src_n;i++)
   {
      uint64_t V;
      switch(src_el)
      {
        case 1: V= *(uint8_t*) in; break;
        case 2: V= *(uint16_t*) in; break;
        case 4: V= *(uint32_t*) in; break;
        case 8: V= *(uint64_t*) in; break;
      }
      in+= src_el;
      switch(dst_el)
      {
        case 1: *(uint8_t*) out= V; break;
        case 2: *(uint16_t*) out= V; break;
        case 4: *(uint32_t*) out= V; break;
        case 8: *(uint64_t*) out= V; break;
      }
      out+= dst_el;
   }
   free(src);
   return dst;
}

int get_window_property_atoms
    (Window window, Atom property, size_t *Rn, Atom **R, int maxn)
{
  int format; Atom type;
  int size; void *data;
  int n,i;

  *R= NULL;
  if (get_window_property(window, property, XA_ATOM,
                          &type, &format, &size, (void**) R,
                          maxn*sizeof(Atom)))
     return 1;
  if (type!=XA_ATOM)
  {
    if (*R) free(*R);
    // FIXME: get the name of the atom to print this better.
    // FIXME log this.
    //fprintf(stderr,"type mismatch in get_window_property \n"
                   //"expected an Atom , but got a %d-bit %d\n",
                              //format, type);
    return 1;
  }

  *Rn= size/sizeof(Atom); 
  return 0;
}


int get_window_property_window
    (Window window, Atom property, Window *R)
{
  Window *data;
  size_t n;
  if (get_window_property_windows(window,property, &n, &data, 1))
     return 1;
  if (n==0) { if (data) free(data); return 1; }
  *R= data[0];
  free(data);
  return 0;
}


int get_window_property_utf8_string
    (Window window, Atom property, size_t *Rn, char **R)
{
  int format; Atom type;
  int size; void *data;
  if (get_window_property(window, property, a_utf8_string,
                          &type, &format, &size, &data, 0))
     return 1;
  if (format!=8 || type!=a_utf8_string)
  {
    if (data) free(data);
    // FIXME: get the name of the atom to print this better.
    // FIXME log this.
    //fprintf(stderr,"type mismatch in get_window_property \n"
                   //"expected a utf8-string, but got a %-bit %d\n",
                              //format, type);
    return 1;
  }
  *Rn= size;
  *R= (char*) data;
  return 0;
}



char *get_active_window_manager_name()
{
  Window child;
  Window child_ref;
  char *child_name;
  size_t dummy;
  if (get_window_property_window(None, a_net_supporting_wm_check, &child))
     return NULL;
  if (get_window_property_window(child, a_net_supporting_wm_check, &child_ref))
     return NULL;
  if (child_ref!=child) return NULL;
  if (get_window_property_utf8_string(child, a_net_wm_name,
                                       &dummy, &child_name))
     return NULL;
  return child_name;
}

#line 506 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

int set_window_property_atoms
        (Window window, Atom property, int n_values, Atom *values)
{
  XChangeProperty(x_display, window, property, XA_ATOM, 32, 
                  PropModeReplace, (unsigned char*) values, n_values);
  return 0;
}

#line 611 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

ximage_t *create_image(uint32_t width, uint32_t height)
{
  ximage_t *image;
  size_t data_size;
  struct shmid_ds dummy_shmid_ds;

  if (!can_use_shared_images()) goto fail_nolib;

  image= calloc(1,sizeof(*image));
  image->width= width;
  image->height= height;
  image->shared= 1;

  // Create the image on the server
  //
  image->x11image= XShmCreateImage(x_display,x_visual, x_depth, ZPixmap,
                                   NULL, &image->shminfo, width, height);
  if (!image->x11image) goto fail_create;

  image->bpl= image->x11image->bytes_per_line;
  data_size= height*image->bpl;

  // Create the shared memory area
  //
  image->shminfo.shmid= shmget(IPC_PRIVATE, data_size, IPC_CREAT | 0777);
  if (image->shminfo.shmid <0)
  {
    fprintf(stderr,"can't shmget shared memory\n");
    goto fail_shmcreate;
  }
  
  image->shminfo.shmaddr= shmat(image->shminfo.shmid,0,0);
   // we remove the ID now, so that when the program exits, the memory
   // will be automatically freed
   //
  shmctl(image->shminfo.shmid, IPC_RMID, &dummy_shmid_ds); 
  if (image->shminfo.shmaddr==(char*) -1) 
  {
    fprintf(stderr,"can't attach shared memory\n");
    goto fail_shmat;
  }

  // bind the area to the image 
  //
  image->data= (uint32_t*) image->shminfo.shmaddr;
  image->x11image->data= (char*) image->shminfo.shmaddr;
  if (!XShmAttach(x_display, &image->shminfo)) 
  {
    fprintf(stderr,"couldn't attach shared memory to the ximage\n");
    goto fail_attach_x;
  }

  return image;

fail_attach_x:
  shmdt(image->shminfo.shmaddr);
fail_shmat:      // We have already removed the ID
fail_shmcreate:
  XDestroyImage(image->x11image);
fail_create:
  free(image);
fail_nolib:
  return ximage_create_simple(width,height);
}

#line 736 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

void destroy_image(ximage_t *image)
{
  image_chore_t *chore;
  if (image->shared) 
  {
    XShmDetach(x_display, &image->shminfo);
    chore= malloc(sizeof(*chore));
    chore->kind= image_chore_shmdt;
    chore->data= image->shminfo.shmaddr;
    chore->next= image_chores;
    image_chores= chore;
  }
  XDestroyImage(image->x11image);
  free(image);
}

void handle_image_chores()
{
  image_chore_t *chore;
  for(chore=image_chores;image_chores;chore=image_chores)
  {
    image_chores= chore->next;
    switch(chore->kind)
    {
      case image_chore_shmdt: shmdt(chore->data); break;
    }
    free(chore);
  }
}

#line 772 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

void put_image(Window window, int dest_x, int dest_y,
               ximage_t *image, int src_x, int src_y,
               int width, int height)
{
  /* the following can happen sometimes, when the window is resized
     and the full-screen exposure for the old size arrives before
     the configure_notify event. FIXME: really? must check this. */
  if (width + src_x> image->width)  width= image->width-src_x;
  if (height+ src_y> image->height) height= image->height-src_y;

  if (image->shared)
    XShmPutImage(x_display, window, DefaultGC(x_display,0),
      image->x11image, src_x, src_y, dest_x, dest_y,
      width, height, False);
  else
    XPutImage(x_display, window, DefaultGC(x_display,0),
      image->x11image, src_x, src_y, dest_x, dest_y,
      width, height);
}


#line 823 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

xwindow_t *create_window(int x,int y,uint32_t width, uint32_t height)
{
  xwindow_t *window;
  XSetWindowAttributes attribs;

  window= malloc(sizeof(*window));

  attribs.background_pixmap= None;
  attribs.override_redirect= True;
  window->x11window= XCreateWindow( x_display, x_root_window,
                                    x, y, width, height,
                                    0, x_depth, InputOutput, 
                                    x_visual, 
                           CWBackPixmap | CWOverrideRedirect, &attribs);
  window->width= width;
  window->height= height;
  window->image= create_image(width, height);
  window->data= window->image->data;

  register_window(window->x11window, window);
  return window;
}

void destroy_window(xwindow_t *window)
{
  XDestroyWindow(x_display,window->x11window);
  destroy_image(window->image);
    // data is part of image, so it gets destroyed above
  unregister_window(window);
  free(window);
}

void invalidate_window(xwindow_t *window)
{
 XClearArea(x_display, window->x11window, 0,0,
               window->width, window->height, True);
  //XFlush(x_display);
}

#line 924 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

int dispatch_window_event(XEvent *event)
{
  XAnyEvent *ev;
  xwindow_t *window;
  ev= (XAnyEvent*) event;
  window= find_window(ev->window);
  if (!window) return 0;
  if (window->event_handler)
     (*window->event_handler)(window, event);
  return 1;
}

#line 943 "/home/dodo/tmp/obpager-1.8/mu/src/xbasics.u"

int handle_window_event(xwindow_t *window, XEvent *event)
{
  XAnyEvent             *ev;
  XExposeEvent          *ev_expo;
  XConfigureEvent       *ev_confi;
  ev= (XAnyEvent*) event;
  switch(ev->type)
  {
   case Expose:
     ev_expo= &event->xexpose;
     put_image(window->x11window, ev_expo->x, ev_expo->y,
               window->image,     ev_expo->x, ev_expo->y,
               ev_expo->width, ev_expo->height);
     return 1;
   case ConfigureNotify:
     ev_confi= &event->xconfigure;
     if (ev_confi->width!=window->width || ev_confi->height!=window->height)
     {
       destroy_image(window->image);
       window->image= create_image(ev_confi->width, ev_confi->height);
       window->data= window->image->data;
       window->width= ev_confi->width;
       window->height= ev_confi->height;
       return 2;
     }
     return 1;
  }
  
  return 0;
}
#line 40 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"

void destroy_client_window(client_window_t *cw)
{
  if (cw->flags&CWF_ICON) free(cw->icon_data);
  free(cw);
}


#line 49 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"

int get_client_list()
{
  Window *windows;
  size_t n_windows;
  client_window_t **clients, *cw;
  int i,j;

  if (get_window_property_windows(x_root_window, 
                                  a_net_client_list_stacking,
                                    &n_windows, &windows, 0))
    return 1;
  clients= malloc(n_windows*sizeof(*clients));
  for(i=0;i<n_windows;i++)
  {
    for(j=0;j<n_client_map;j++)
      if (client_map[j]->id==windows[i])
        break;
    if (j==n_client_map)
    {
      cw= calloc(1,sizeof(*cw));
      cw->id= windows[i];
      cw->flags= 0; cw->tried= 0;
      if (cw->id!=pager_window->x11window)
        XSelectInput(x_display, cw->id, 
              StructureNotifyMask | PropertyChangeMask);
    } 
    else
    {
      cw= client_map[j];
      client_map[j]= client_map[n_client_map-1];
      n_client_map--;
    } 
    clients[i]= cw;
  }

  for(j=0;j<n_client_map;j++)
    destroy_client_window(client_map[j]);
  if (client_map) free(client_map);

  client_map= clients;
  n_client_map= n_windows;

  free(windows);
  return 0;
}

#line 100 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"


uint32_t* copy_ulong_to_uint32(unsigned long *data,uint32_t elems)
{
  uint32_t *d,i;
  d= malloc(elems*sizeof(uint32_t));
  for(i=0;i<elems;i++) d[i]= data[i];
  return d;
}

int get_client_icon(client_window_t *cw, uint32_t twidth, uint32_t theight)
{
  unsigned long *idata; 
  size_t n_idata;

  if (cw->flags & CWF_ICON) return 0;
  if (cw->tried & CWF_ICON) return 1;
  cw->tried |= CWF_ICON;
  if (get_window_property_cardinals(cw->id, a_net_wm_icon, &n_idata, &idata,0))
     return 1;
  
  unsigned long *maxi;
  unsigned long *besti,*icon;
  maxi= NULL; besti= NULL;
  for(icon=idata;icon+1<idata+n_idata;icon+= icon[0]*icon[1]+2)
  {
    if (!maxi) 
    { 
      maxi= icon;
    }
    else
    {
      if (icon[0]*icon[1] > maxi[0]*maxi[1]) maxi= icon;
    }
    if (icon[0]>twidth || icon[1]>theight) continue;
    if (!besti) { besti= icon; continue; }
    if (icon[0]*icon[1] > besti[0]*besti[1]) besti= icon;
  }

  if (!besti && !maxi) goto fail;

  if (besti)
  {
    cw->icon_width= besti[0];
    cw->icon_height= besti[1];
    cw->icon_data= copy_ulong_to_uint32(besti+2, besti[0]*besti[1]);
  }
  else
  {
    uint32_t *d;
    d= copy_ulong_to_uint32(besti+2, besti[0]*besti[1]);
    if (resize_image_argb(d, maxi[0], maxi[1],
                          twidth, theight,
                          &cw->icon_data, &cw->icon_width, &cw->icon_height))
    {
       free(d);
       goto fail;
    }
    free(d);
  }
  
  free(idata);
  cw->flags|= CWF_ICON;
  return 0;
fail:
  free(idata); 
  return 1;
}

int get_client_pos(client_window_t *cw)
{
  Window dummy_window;
  int dummy_int; unsigned int dummy_unt;
  unsigned int w,h;

  if (cw->flags & CWF_POS) return 0;
  if (cw->tried & CWF_POS) return 1;
  cw->tried |= CWF_POS;

  XGetGeometry(x_display, cw->id, &dummy_window, &dummy_int, &dummy_int,
                          &w, &h, &dummy_unt, &dummy_unt);

  cw->width= w; cw->height= h;

  XTranslateCoordinates(x_display, cw->id, x_root_window, 0,0,
                        &cw->x, &cw->y, &dummy_window);

  cw->flags|= CWF_POS;
  return 0;
}

int get_client_state(client_window_t *cw)
{
  size_t n_values; Atom *values;
  int i;

  if (cw->flags&CWF_STATE) return 0;
  if (cw->tried&CWF_STATE) return 1;
  cw->tried |= CWF_STATE;
  cw->flags |= CWF_STATE;
  cw->state= 0; // if no state, assume normal

  if (get_window_property_atoms(cw->id, a_net_wm_state, &n_values, &values,0))
    return 0;
  for(i=0;i<n_values;i++)
    if (values[i]==a_net_wm_state_hidden)
    {
      cw->state= 1;
      break;
    } 
  free(values);
  return 0;
}

int get_client_type(client_window_t *cw)
{
  size_t n_values; Atom *values;
  int i;

  if (cw->flags&CWF_TYPE) return 0;
  if (cw->tried&CWF_TYPE) return 1;
  cw->tried |= CWF_TYPE;
  cw->flags |= CWF_TYPE;
  cw->type= 0; // if no type, assume normal

  if (get_window_property_atoms(cw->id, a_net_wm_window_type, 
                                 &n_values, &values,0))
    return 0;

  cw->type= 1;
  
  for(i=0;i<n_values;i++)
    if (values[i]==a_net_wm_window_type_normal)
    {
      cw->type= 0;
      break;
    } 
  free(values);
  return 0;
}

int get_client_desktop_number(client_window_t *cw)
{
  if (cw->flags&CWF_DESK) return 0;
  if (cw->tried&CWF_DESK) return 1;

  cw->tried |= CWF_DESK;

  if (get_window_property_cardinal(cw->id, a_net_wm_desktop,
                                     &cw->desk))
    return 1;

  cw->flags |= CWF_DESK;
  return 0;
}

#line 279 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"

void render_pager_background
   (xwindow_t *window, int ndesks, 
    int *Rpadl, int *Rpadt, int *Rpagew, int *Rpageh)
{
   int windoww, windowh;
   int pagew, pageh;
   int areaw, areah;
   int padt, padb, padl, padr;
   int i;

   if (ndesks<1) ndesks= 1;

   windoww= window->width;
   windowh= window->height;

   /* ndesks*(pagew+1)+1 <= windoww 
             pagew       <= (windoww-1)/ndesks-1 */

   pagew= (windoww-1)/ndesks - 1;
   if (pagew<1) return ;
   
   pageh= (double) x_root_height / x_root_width * pagew; 
   if (pageh+2>windowh) 
   {
     pageh= windowh-2; 
     pagew= (double) x_root_width / x_root_height * pageh;
   }

   if (pagew<1 || pageh<1) return ;

   areaw= (pagew+1)*ndesks+1;
   padl= (windoww - areaw)/2;
   padr= windoww - areaw - padl;

   areah= pageh+2;
   padt= (windowh - areah)/2;
   padb= windowh - areah - padt;

   window_fill_rectangle(window, pc_border,0,0, padl, windowh);
   window_fill_rectangle(window, pc_border,padl+areaw,0, padr, windowh);
   window_fill_rectangle(window, pc_border,0,0, windoww, padt);
   window_fill_rectangle(window, pc_border,0, padt+areah, windoww, padb);

   for(i=0;i<=ndesks;i++)
      window_vert_line(window, pc_border, padl+i*(pagew+1), padt, padt+areah);

   window_horz_line(window, pc_border, padl, padl+areaw, padt);
   window_horz_line(window, pc_border, padl, padl+areaw, padt+pageh+1);

   for(i=0;i<ndesks;i++)
     window_fill_rectangle(window, i==x_current_desktop?
                                     pc_a_root : pc_i_root, 
                                   padl+i*(pagew+1)+1, padt+1, 
                                   pagew, pageh);

   *Rpadl= padl; *Rpadt= padt;
   *Rpagew= pagew; *Rpageh= pageh;
}

void render_mini_window(xwindow_t *window, int ndesks, 
                        int padl, int padt, int pagew, int pageh,
                        client_window_t *cw)
{
   int w_x, w_y, w_w, w_h;
   int desk_s, desk_e, desk;
   int p_x, p_y, p_w, p_h;

   if (get_client_state(cw) || cw->state) 
     { //printf("skipping window %d because of state\n", (int) cw->id); 
       return ; }
   if (!get_client_type(cw) && cw->type) 
     { //printf("skipping window %d because of type\n", (int) cw->id); 
       return ; }
   if (get_client_pos(cw))
        { w_x= 0; w_y= 0; w_w= x_root_width; w_h= x_root_height; }
   else { w_x= cw->x; w_y= cw->y; w_w= cw->width; w_h= cw->height; }

   if (get_client_desktop_number(cw) || cw->desk<0 || cw->desk>=ndesks)
        { desk_s= 0; desk_e= ndesks-1; }
   else desk_s= desk_e= cw->desk;

   get_client_icon(cw, 20,20); // FIXME: not 25x25, something flexible.

   if (w_x<0) { w_w+= w_x; w_x= 0; }
   if (w_y<0) { w_h+= w_y; w_y= 0; }

   if (w_x+w_w>x_root_width) w_w= x_root_width - w_x;
   if (w_y+w_h>x_root_height) w_h= x_root_height - w_y;

   //printf("window %d w_x= %d w_y= %d w_w= %d w_h= %d\n",
   //         (int) cw->id, w_x, w_y, w_w, w_h);

   p_x= (double) w_x / x_root_width * pagew;
   p_y= (double) w_y / x_root_height * pageh;
   p_w= (double) w_w / x_root_width * pagew;
   p_h= (double) w_h / x_root_height * pageh;

   if (p_w<3 || p_h<3) return ;

   for(desk=desk_s;desk<=desk_e;desk++)
   {
      window_draw_rectangle(window,
              desk==x_current_desktop ? pc_a_window_border: pc_i_window_border, 
              padl + desk*(pagew+1) + p_x,
              padt + 1 + p_y, p_w, p_h);
      window_fill_rectangle(window,
              desk==x_current_desktop ? pc_a_window : pc_i_window, 
              padl+ desk*(pagew+1) + p_x+1,
              padt+ 1 + p_y+1, p_w-2, p_h-2);

      draw_client_icon(window, cw, 
              padl + desk*(pagew+1) + p_x,
              padt + 1 + p_y, p_w, p_h, desk==x_current_desktop);

//      printf("drawing window %d in desk %d p_x=%d p_y=%d p_w= %d p_h=%d\n", 
//              (int) cw->id, desk, p_x, p_y, p_w, p_h);
   }
}

#line 408 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"

void convert_pager_color(uint32_t *tgt)
{
  uint32_t V, R,G,B;
  V= *tgt;
  R= (V>>16)&0xff;
  G= (V>>8)&0xff;
  B= (V>>8)&0xff;
  *tgt= (R<<x_red_shift) | (G<<x_green_shift) | (B<<x_blue_shift);
}

void render_pager_window()
{
   int pagew, pageh, padl, padt;
   int i;

   if (!pc_converted)
   {
     pc_converted= 1;
     convert_pager_color(&pc_border);
     convert_pager_color(&pc_a_root);
     convert_pager_color(&pc_a_window);
     convert_pager_color(&pc_a_window_border);
     convert_pager_color(&pc_i_root);
     convert_pager_color(&pc_i_window);
     convert_pager_color(&pc_i_window_border);
   }

   render_pager_background(pager_window, x_n_desktops,
                                         &padl, &padt, &pagew, &pageh);

   for(i=0;i<n_client_map;i++)
      render_mini_window(pager_window, x_n_desktops,
                         padl, padt, pagew, pageh,
                         client_map[i]);
}

void argb_to_a_server(uint32_t V, uint32_t *A, uint32_t *P)
{
  uint32_t R,G,B;
  R= (V>>16)&0xff;
  G= (V>>8)&0xff;
  B= (V>>8)&0xff;
  *A= (V>>24) & 0xff;
  *P= (R<<x_red_shift) | (G<<x_green_shift) | (B<<x_blue_shift);
}

void draw_client_icon
     (xwindow_t *window,client_window_t *cw,int x,int y,int w,int h,
      int active)
{
  int r,c;
  uint32_t P,A;
  uint32_t bP,bR, bG, bB, R, G, B;
  double V;

  if (active) bP= pc_a_window; else bP= pc_i_window;

  if (cw->flags&CWF_ICON==0) return ;
  if (cw->icon_width>w || cw->icon_height>h) return ;

  x+= (w-cw->icon_width)/2;
  y+= (h-cw->icon_height)/2;

  bR= (bP >> x_red_shift) & 0xff;
  bG= (bP >> x_green_shift) & 0xff;
  bB= (bP >> x_blue_shift) & 0xff;

  for(r=0;r<cw->icon_height;r++)
    for(c=0;c<cw->icon_width;c++)
    {
       P= cw->icon_data[r*cw->icon_width+c];
       R= (P >> 16 ) & 0xff;
       G= (P >> 8 ) & 0xff;
       B= (P >> 0 ) & 0xff;
       A= (P >> 24) & 0xff;

       V= (double) A / 255.0;
       R= (R*V + bR*(1-V));
       G= (G*V + bG*(1-V));
       B= (B*V + bB*(1-V));

       P= (R<<x_red_shift) | (B<<x_blue_shift) | (G<<x_green_shift);
       window->data[ (y+r)*window->width + (x+c) ]= P;
    }
}

#line 500 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"

void handle_root_event(XEvent *event)
{
  XPropertyEvent *pe;
  if (event->type!=PropertyNotify) return ;
  pe= &event->xproperty;
  if (pe->state!=PropertyNewValue) return ;
  if (pe->atom==a_net_client_list_stacking)
  {
    get_client_list();
    render_pager_window();
    invalidate_window(pager_window);
    return ;
  }
  if (pe->atom==a_net_current_desktop)
  {
    int cd;
    if (get_current_desktop(&cd)) return ;
    if (cd==x_current_desktop) return ;
    x_current_desktop= cd;
    render_pager_window();
    invalidate_window(pager_window);
    return ;
  }
  if (pe->atom==a_net_number_of_desktops)
  {
    uint32_t nd;
    int x,y,w,h;
    if (get_number_of_desktops(&nd)) return ;
    if (nd==x_n_desktops) return ;
    x_n_desktops= nd;
    pager_window_shape(opt_refsize, opt_bottom, opt_right,
                       &w, &h, &x, &y);
    XMoveResizeWindow(x_display, pager_window->x11window, x,y, w,h);
    return ;
  }
}

#line 543 "/home/dodo/tmp/obpager-1.8/mu/src/clients.u"

int handle_client_event(XEvent *event)
{
  int i;
  client_window_t *cw;
  for(i=0;i<n_client_map;i++)
    if (event->xany.window==client_map[i]->id)
       break;
  if (i==n_client_map) return 0;
  cw= client_map[i];
  switch(event->type)
  {
   case ConfigureNotify:
     cw->flags &= ~CWF_POS;
     cw->tried &= ~CWF_POS;
     goto render;
   case PropertyNotify:
     if (event->xproperty.atom==a_net_wm_state)
     {
       cw->flags &= ~CWF_STATE;
       cw->tried &= ~CWF_STATE;
       goto render;
     }
     if (event->xproperty.atom==a_net_wm_desktop)
     {
       cw->flags &= ~CWF_DESK;
       cw->tried &= ~CWF_DESK;
       goto render;
     }
     break;
  }
  return 0;
render:
  render_pager_window();
  invalidate_window(pager_window);
  return 1;
}
#line 5 "/home/dodo/tmp/obpager-1.8/mu/src/gfx.u"

void window_fill_rectangle
   (xwindow_t *window,uint32_t color, int x,int y, int w, int h)
{
  int X,Y;
  if (y<0) { h+= y; y= 0; }
  if (x<0) { w+= x; x= 0; }
  if (x+w>window->width) { w= window->width- x; }
  if (y+h>window->height) { h= window->height- y; }

  if (x>=window->width || y>=window->height || w<=0 || h<=0) return ;

  for(Y=y;Y<y+h;Y++)
    for(X=x;X<x+w;X++)
      window->data[Y*window->width + X]= color;
}

void window_draw_rectangle
   (xwindow_t *window,uint32_t color, int x,int y, int w, int h)
{
  window_horz_line(window, color, x, x+w-1, y);
  window_horz_line(window, color, x, x+w-1, y+h-1);
  window_vert_line(window, color, x, y, y+h-1);
  window_vert_line(window, color, x+w-1, y, y+h-1);
}


void window_horz_line
   (xwindow_t *window,uint32_t color, int x1, int x2, int y)
{
  int U;

  if (x1>x2) { U=x1; x1= x2; x2= U; }

  if (x1<0) x1= 0; if (x2>=window->width) x2= window->width-1;
  if (y<0 || y>=window->height) return ;

  while(x1<=x2) {
    window->data[y*window->width + x1]= color;
    x1++;
  }
}


void window_vert_line
   (xwindow_t *window,uint32_t color, int x, int y1, int y2)
{
  int U;

  if (y1>y2) { U=y1; y1= y2; y2= U; }

  if (y1<0) y1= 0; if (y2>=window->height) y2= window->height-1;
  if (x<0 || x>=window->width) return ;

  while(y1<=y2) {
    window->data[y1*window->width + x]= color;
    y1++;
  }
}

#line 150 "/home/dodo/tmp/obpager-1.8/mu/src/main.u"

void pager_window_shape(int ref, int bot_off, int right_off,
                        int *window_w, int *window_h,
                        int *window_x, int *window_y)
{
   int W,H;
   double vS, hS,S;
   int pH, pW;

   vS= (double) ref / x_root_height;
   hS= (double) ref / x_root_width;

   if (vS>hS) S= hS; else S= vS;
   pW= S * x_root_width;
   pH= S * x_root_height;

   W= x_n_desktops * (pW+1) + 1;
   H= pH + 2;

  *window_w= W;
  *window_h= H;
  *window_x= x_root_width - W - right_off;
  *window_y= x_root_height- H - bot_off;
}

void usage()
{
   puts(
#line 1574 "mupager-main.c"
"/*\n"
"This is mupager-1. It\047s a pager based on the NETWM specification.\n"
"I didn\047t follow it completely, but it mostly works fine.\n"
"\n"
"Copyright 2014 Sukru Cinar\n"
"\n"
"All rights reserved.\n"
"\n"
"Redistribution and use in source and binary forms, with or without\n"
"modification, are permitted provided that the following conditions\n"
"are met:\n"
"\n"
"1. Redistributions of source code must retain the above copyright notice,\n"
"   this list of conditions and the following disclaimer.\n"
"\n"
"2. Redistributions in binary form must reproduce the above copyright\n"
"   notice, this list of conditions and the following disclaimer in the\n"
"   documentation and/or other materials provided with the distribution.\n"
"\n"
"THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n"
"\042AS IS\042 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\n"
"LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\n"
"A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\n"
"HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\n"
"SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED\n"
"TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR\n"
"PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF\n"
"LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING\n"
"NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS\n"
"SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\n"
"\n"
"INSTALLATION\n"
"\n"
"Just compile the given C source file as such:\n"
"\n"
"  cc -o mupager mupager.c -lXext -lX11 -lm\n"
"\n"
"There is nothing to \047install\047 except for the above generated binary.\n"
"\n"
"RUNNING\n"
"\n"
"The pager tries to run in the bottom right corner. If you have something\n"
"else there, you can specify how far it should stay away from the respective\n"
"edge using the following command line options:\n"
"\n"
"  -right N\n"
"      The right edge of the created window will be N pixels away from the\n"
"      desktop border.\n"
"  -bottom N\n"
"      The same thing, but for the bottom edges.\n"
"\n"
"You can also specify how big the pager \047panels\047 should be. This is given\n"
"by:\n"
"\n"
"  -refsize N\n"
"      One dimension of each panel will be approximately (maybe smaller \n"
"      than) X pixels. The other dimension is calculated using the aspect\n"
"      ratio of your screen.\n"
"*/\n"

#line 182 "/home/dodo/tmp/obpager-1.8/mu/src/main.u"
   );
   exit(1);
}

#line 31 "/home/dodo/tmp/obpager-1.8/mu/src/main.u"

void draw_line(xwindow_t *window)
{
  int x;
  for(x=0;x<window->width*window->height;x++) window->data[x]= 0;
  for(x=0;x<window->width;x++)
    if (x<window->height)
      window->data[x*(window->width+1)]= 0xff0000;
  XClearArea(x_display, window->x11window, 0,0, window->width,
                 window->height, True);
}

void test_event_handler(xwindow_t *window, XEvent *event)
{
  int R,x,w;
  R= handle_window_event(window, event);
  switch(event->type)
  {
  case ConfigureNotify:
//     if (R==2) printf("resize\n");
     return ;
  case ButtonPress:
     x= event->xbutton.x;
     w= window->width / x_n_desktops;
     set_current_desktop(x/w);
  }
}

xwindow_t *main_window;

void destroy_all()
{
  destroy_window(main_window);
}

void shift_args(int *argc,char **argv)
{
   int j;
   for(j=1;j<*argc-1;j++) argv[j]= argv[j+1];
   *argc -= 1;
}

int main(int argc,char **argv)
{
  xwindow_t *window;
  int pw,ph,px,py;
  int i;

  if (init_display(NULL)) return 1;

  while(argc>1)
  {
    int *itgt;
    itgt= NULL;
    if (!strcmp(argv[1],"-right"))
      itgt= &opt_right;
    else if (!strcmp(argv[1],"-bottom"))
      itgt= &opt_bottom;
    else if (!strcmp(argv[1],"-refsize"))
      itgt= &opt_refsize;
    else if (!strcmp(argv[1],"-v") || !strcmp(argv[1],"-h"))
      usage();
    shift_args(&argc,argv);
    if (itgt && argc>1) { *itgt= atoi(argv[1]); shift_args(&argc,argv); }
  }

  pager_window_shape(opt_refsize, opt_bottom, opt_right,
                     &pw, &ph, &px, &py);  

  main_window= window= create_window(px,py,pw,ph);

  window->event_handler= test_event_handler;

  XSelectInput(x_display, window->x11window, 
               ExposureMask | StructureNotifyMask | ButtonPressMask);


  Atom v[20];

  i= 0;
  v[i++]= a_net_wm_window_type_dock;
  set_window_property_atoms(window->x11window, a_net_wm_window_type, i,v);

  i= 0;
  v[i++]= a_net_wm_state_sticky;
  v[i++]= a_net_wm_state_skip_taskbar;
  v[i++]= a_net_wm_state_skip_pager;
  set_window_property_atoms(window->x11window, a_net_wm_state, i, v);

  XMapWindow(x_display, window->x11window);
  pager_window= window; 

  get_client_list();
  render_pager_window();

  XSelectInput(x_display, x_root_window, PropertyChangeMask);

  XEvent event;

  atexit(destroy_all);

  while(1)
  {
    XNextEvent(x_display,&event);
    if (event.xany.window==pager_window->x11window)
    {  dispatch_window_event(&event); continue; }
    if (event.xany.window==x_root_window)
      { handle_root_event(&event); continue; }
    if (handle_client_event(&event)) continue;
  }

  return 0;
}

